    title "Zegar na wyświetlaczu 7-segmentowym ze wspólną anodą"
    subtitle "Katody sterowane z mikrokontrolera, katody przez tranzystory PNP"


    processor pic18f14k22
    #include p18f14k22.inc
; CONFIG1H
  CONFIG  FOSC = IRC            ; Oscillator Selection bits (Internal RC oscillator)
  CONFIG  PLLEN = OFF           ; 4 X PLL Enable bit (PLL is under software control)
  CONFIG  PCLKEN = OFF          ; Primary Clock Enable bit (Primary clock is under software control)
  CONFIG  FCMEN = OFF           ; Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor disabled)
  CONFIG  IESO = OFF            ; Internal/External Oscillator Switchover bit (Oscillator Switchover mode disabled)

; CONFIG2L
  CONFIG  PWRTEN = OFF          ; Power-up Timer Enable bit (PWRT disabled)
  CONFIG  BOREN = SBORDIS       ; Brown-out Reset Enable bits (Brown-out Reset enabled in hardware only (SBOREN is disabled))
  CONFIG  BORV = 19             ; Brown Out Reset Voltage bits (VBOR set to 1.9 V nominal)

; CONFIG2H
  CONFIG  WDTEN = OFF           ; Watchdog Timer Enable bit (WDT is controlled by SWDTEN bit of the WDTCON register)
  CONFIG  WDTPS = 32768         ; Watchdog Timer Postscale Select bits (1:32768)

; CONFIG3H
  CONFIG  HFOFST = ON           ; HFINTOSC Fast Start-up bit (HFINTOSC starts clocking the CPU without waiting for the oscillator to stablize.)
  CONFIG  MCLRE = OFF           ; MCLR Pin Enable bit (RA3 input pin enabled; MCLR disabled)

; CONFIG4L
  CONFIG  STVREN = ON           ; Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
  CONFIG  LVP = OFF             ; Single-Supply ICSP Enable bit (Single-Supply ICSP disabled)
  CONFIG  BBSIZ = OFF           ; Boot Block Size Select bit (1kW boot block size)
  CONFIG  XINST = OFF           ; Extended Instruction Set Enable bit (Instruction set extension and Indexed Addressing mode disabled (Legacy mode))

; CONFIG5L
  CONFIG  CP0 = OFF             ; Code Protection bit (Block 0 not code-protected)
  CONFIG  CP1 = OFF             ; Code Protection bit (Block 1 not code-protected)

; CONFIG5H
  CONFIG  CPB = OFF             ; Boot Block Code Protection bit (Boot block not code-protected)
  CONFIG  CPD = OFF             ; Data EEPROM Code Protection bit (Data EEPROM not code-protected)

; CONFIG6L
  CONFIG  WRT0 = OFF            ; Write Protection bit (Block 0 not write-protected)
  CONFIG  WRT1 = OFF            ; Write Protection bit (Block 1 not write-protected)

; CONFIG6H
  CONFIG  WRTC = OFF            ; Configuration Register Write Protection bit (Configuration registers not write-protected)
  CONFIG  WRTB = OFF            ; Boot Block Write Protection bit (Boot block not write-protected)
  CONFIG  WRTD = OFF            ; Data EEPROM Write Protection bit (Data EEPROM not write-protected)

; CONFIG7L
  CONFIG  EBTR0 = OFF           ; Table Read Protection bit (Block 0 not protected from table reads executed in other blocks)
  CONFIG  EBTR1 = OFF           ; Table Read Protection bit (Block 1 not protected from table reads executed in other blocks)

; CONFIG7H
  CONFIG  EBTRB = OFF           ; Boot Block Table Read Protection bit (Boot block not protected from table reads executed in other blocks)


    
gdzies	UDATA			; dane relokowalne. Zwykle używamy takich
	
zwlocz	    RES	1		; zmienna dla pętli zwłoki
czytotyle   RES 1		; dla procedury koduj1znak
bin	    RES	1		; dla procedury bin8ToBCD3
bcdH	    RES	1
pmins	    RES 1
zliczacz256 RES 1		; liczy ilość przerwań. Dzielnik przez 256
cyfra	    RES 1		; Numer aktualnie wyświetlanej cyfry, Zmieniany w przerwaniu co 1/256 sekundy
hours	    RES	1		; Zmieniane w przerwaniu
mins	    RES	1
secs	    RES	1	    
hoursBCD    RES 1		; to samo, ale zakodowane BCD
minsBCD	    RES 1		; j.w.
wyswietlacz RES 4		; dane przygotowane dla wyświetlacza dla poszczególnych cyfr
				; wyswietlacz	- 1 cyfra godzin
				; wyswietlacz+1 - 2 cyfra godzin
				; wyswietlacz+2 - 1 cyfra minut
				; wyswietlacz+3 - 2 cyfra minut
tmp_wysw    RES 4		; zmienna tymczasowa
funkcja	    RES 1		; Aktualna funkcja przycisków sterujących
				; 0 - żadna. Zwykła praca
				; 1 - ustawianie godzin
				; 2 - ustawianie minut
				; Znakiem, że coś ustawiamy jest to, że nie miga dwukropek
zwlocz100  RES 1		; Dla policzenia zwłoki 100ms				

start	CODE	0
	GOTO	begin
isr	CODE	0x08
	goto	przerwanie

main	CODE
begin:
    ; Ustawiamy oscylator
    MOVLW B'01010010'	; częstotliwośc pracy ustawiamy bitami 6:4
    ;        ^^^
			; 111 - 16MHz; 110 - 8MHz; 101 - 4MHz; 100 - 2MHz; 011 - 1MHz;
			; 010 - 500kHz; 001 - 250kHz; 000 - 31kHz
    MOVWF   OSCCON
    ; Możemy też włączyć PLL gdy Fosc = 8 lub 16MHz
    BSF	    OSCTUNE, 6
    ; Konfiguracja końcówek
    CLRF    LATA		; Instrukcja CLRF od razu zeruje rejestr
    MOVLW   B'00101011'		; Ale jeśli chcemy wpisać konkretną liczbę musimy to zrobić dwuetapowo,
    MOVWF   TRISA		; przy pomocy MOVLW i MOVWF
    MOVLW   B'00001011'		; Podciągi na RA0, RA1 i RA3
    MOVWF   WPUA
    BCF	    INTCON2, NOT_RABPU	; i wglobalne włączenie podciągów
    CLRF    LATB
    CLRF    TRISB
    CLRF    LATC
    CLRF    TRISC
    ; Wyłączenie wejść analogowych, bo domyślnie sa włączone
    CLRF    ANSEL
    CLRF    ANSELH
    ; Start przerwań
    BSF	    INTCON, GIE
    BSF	    INTCON, PEIE
    ; Włączamy Timer1 jako RTC
    CALL    RTCinit
    ; Peryferia
    CLRF    funkcja
    CLRF    secs		; Inicjalizacja rejestrów zawierających czas
    CLRF    mins
    MOVLW   .12
    MOVWF   hours
    CALL    Koduj_Hours
    CALL    Koduj_Mins
    
; *************************************************************************    
; ************************* PĘTLA GŁÓWNA PROGRAMU *************************
; *************************************************************************
    
petla1:
    BTFSS   PORTA, 3    ; Czy wciśnięto przycisk "Funkcja" ? 
    BRA	    p_funkcja	    ; Tak
    BTFSS   PORTA, 0	    ; Nie. Czy wciśnięto przycisk "Zwiększ" ? 
    BRA	    p_zwieksz	    ; Tak
    BTFSS   PORTA, 1	    ; Nie. Czy wciśnięto przycisk "Zmniejsz" ? 
    BRA	    p_zmniejsz	    ; Tak
    BRA	    petla1	    ; I tak w kółko...
 
; wciśnięto klawisz "funkcja"
p_funkcja:
    CALL    zwloka300ms
    BTFSS   PORTA, 3
    BRA	    p_funkcja1	    ; Po 300ms nadal wciśnięty. Zaliczone!
    BRA	    petla1	    ; Po 300 ms puszczony. Anulujemy
p_funkcja1:
    INCF    funkcja	    ; zmiana funkcji
    MOVLW   3
    CPFSLT  funkcja
    CLRF    funkcja
p_funkcja2:
    BTFSS   PORTA, 3	    ; Czekamy, aż klawisz zostanie puszczony
    BRA	    p_funkcja2
    CLRF    secs
    CALL    RTCinit
    BRA	    petla1

; wciśnięto przycisk "zwiększ"    
p_zwieksz:
    MOVLW   0
    CPFSGT  funkcja	    ; Czy "funkcja" jest > 0 ?
    BRA	    petla1	    ; Nie. Kończymy
    INCF    WREG
    CPFSGT  funkcja	    ; Czy "funkcja" jest > 1 ?
    BRA	    zwieksz_hours   ; Nie. Zwiększamy godziny
zwieksz_mins:		    ; Tak. zwiększamy minuty
    INCF    mins,F	    ; Zwiększ minuty
    MOVLW   .59		    ; Czy osiągnięto 60 minut?
    CPFSGT  mins
    BRA	    zwieksz_mins1   ; Nie, nie ma nic więcej do zrobienia
    CLRF    mins	    ; wyzeruj minuty
zwieksz_mins1:
    CALL    Koduj_Mins
    BRA	    koncz_zwieksz
zwieksz_hours:
    INCF    hours,F	    ; Zwiększ godziny
    MOVLW   .23		    ; Czy osiągnięto 24 godziny?
    CPFSGT  hours
    BRA	    zwieksz_hours1  ; Nie, nie ma nic więcej do zrobienia
    CLRF    hours	    ; wyzeruj godziny
zwieksz_hours1:
    CALL    Koduj_Hours
koncz_zwieksz:
    CALL    zwloka300ms
    BRA	    petla1	    ; Nie, już puszczono

; wciśnięto przycisk "zmniejsz"    
p_zmniejsz:    
    MOVLW   0
    CPFSGT  funkcja	    ; Czy "funkcja" jest > 0 ?
    BRA	    petla1	    ; Nie. Kończymy
    INCF    WREG
    CPFSGT  funkcja	    ; Czy "funkcja" jest > 1 ?
    BRA	    zmniejsz_hours  ; Nie. Zmniejszamy godziny
zmniejsz_mins:		    ; Tak. Zmniejszamy minuty
    DECF    mins,F	    ; Zmniejsz minuty
    MOVLW   .59		    ; Czy zeszliśmy poniżej 0? Jeżeli tak, to liczba jest większa niż 59
    CPFSGT  mins
    BRA	    zmniejsz_mins1  ; Nie, nie ma nic więcej do zrobienia
    MOVWF   mins	    ; ustaw 59 minut
zmniejsz_mins1:
    CALL    Koduj_Mins
    BRA	    koncz_zmniejsz
zmniejsz_hours:
    DECF    hours,F	    ; Zmniejsz godziny
    MOVLW   .23		    ; Czy zeszliśmy poniżej 0? Jeżeli tak, to liczba jest większa niż 23
    CPFSGT  hours
    BRA	    zmniejsz_hours1 ; Nie, nie ma nic więcej do zrobienia
    MOVWF   hours	    ; Ustaw godzinę 23
zmniejsz_hours1:
    CALL    Koduj_Hours
koncz_zmniejsz:
    CALL    zwloka300ms
    BRA	    petla1	    ; Nie, już puszczono

    GOTO $		; Pułapka. Dalej nie pójdzie


; PODPROGRAMY **************************************************************

; Podprogram zwloka  
    ; Poniższy podprogram powoduje zwłokę 1000 cykli maszynowych
    ; Przy Fosc=4MHz wykonuje 1mln instr/s czyli czas jednego cyklu to 1µs
    ; A więc zwłoka trwa 1ms czyli 1/1000 s
zwloka:			; skok tu to 2 cykle maszynowe
    MOVLW .198		; 1 cykl
    MOVWF zwlocz	; 1 cykl
zwloka1:
    nop			; 1 cykl
    nop			; 1 cykl
    DECFSZ zwlocz, f	; Zmniejsz o 1, przeskocz 1 instrukcję jeśli 0
    BRA zwloka1
    nop			; ta instrukcja byłaby niepotrzebna, gdybyśmy użyli powyżej GOTO zamiast BRA
    nop			; 1 cykl
    nop			; 1 cykl
    nop			; 1 cykl
    nop			; 1 cykl
    RETURN		; 2 cykl

    
; Podprogram zwloka100ms. Nie jest tak dokładny jak "zwloka", ale w tym zastosowaniu to nie ma znaczenia
    ; Odmierza zwłokę 100ms (1/10 s)
zwloka100ms:
    MOVLW	.100
    MOVWF	zwlocz100
zwloka100a:
    CALL	zwloka
    DECFSZ	zwlocz100, f	; Zmniejsz o 1, przeskocz 1 instrukcję jeśli 0
    BRA		zwloka100a
    RETURN
    
; Podprogram zwloka500ms. Nie jest tak dokładny jak "zwloka", ale w tym zastosowaniu to nie ma znaczenia
    ; Odmierza zwłokę 500ms (1/10 s)
zwloka300ms:
    CALL	zwloka100ms
    CALL	zwloka100ms
    CALL	zwloka100ms
    RETURN
    
; input  : bin       = 8-bit binary
; output : bcdH:WREG = 3-digit packed BCD
; Źródło: http://www.microchip.com/forums/m599197.aspx
Bin8ToBCD3:
        clrf    WREG            ; clear bcd digits
        clrf    bcdH            ;
        bsf     bcdH,0          ; set bits count = 8
bcd_lp:
	rlcf    bin             ; shift bit out of binary
        addwfc  WREG            ; and into bcd
        daw                     ; adjust bcd digits
        rlcf    bcdH            ;
        bnc     bcd_lp          ; loop until 8 bits
        return                  ; exit
    
Koduj_Hours:
    ; Przekodowuje godziny do BCD
    MOVFF   hours,bin
    CALL    Bin8ToBCD3
    MOVWF   hoursBCD
    ; a teraz na kody dla wyświetlacza
    SWAPF   hoursBCD,w
    CALL    koduj1znak
    MOVWF   wyswietlacz
    MOVF    hoursBCD,w
    CALL    koduj1znak
    MOVWF   wyswietlacz+1
    RETURN

Koduj_Mins:
    ; Przekodowuje minuty do BCD
    MOVFF   mins,bin
    CALL    Bin8ToBCD3
    MOVWF   minsBCD
    ; a teraz na kody dla wyświetlacza
    SWAPF   minsBCD,w
    CALL    koduj1znak
    MOVWF   wyswietlacz+2
    MOVF    minsBCD,w
    CALL    koduj1znak
    MOVWF   wyswietlacz+3
    RETURN
    
Wyswietl1znak:
    ; to, który znak wyświetlać, jest zależne od zmiennej "cyfra"
    ; Zmienna ta może mieć wartości tylko 1, 2, 3 i 4
    DECF    cyfra, w	    ; WREG := cyfra - 1
    ADDLW   wyswietlacz	    ; Uwaga! w tej instrukcji zostanie wzięty pod uwagę ADRES do zmiennej wyswietlacz,
			    ; bo instrukcja ADDLW operuje na operandzie bezpośrednim a nie zmiennej
    ; Poniżej adresowanie względne. Adres zostanie utworzony przez FSR i ustawioną stronę pamięci. Ale w tym
    ; programie nie zmieniamy strony, bo nie używamy tylu zmiennych
    MOVWF   FSR1L
    SETF    LATB	    ; Tu są anody przez tranzystory PNP. Na chwilę wyłączamy wyświetlanie czegokolwiek
    MOVFF   INDF1, LATC	    ; INDF to rejest logiczny. Jego zawartość jest równa rejestrowi adresowanemu przez FSR
    ; Dodanie oznakowania ustawiania funkcji
    MOVLW   0
    CPFSGT  funkcja
    BRA	    teraz_anody
    INCF    WREG
    CPFSGT  funkcja	    ; czy 1 - ustawiamy godziny ?
    BRA	    zaznacz_godziny ; Tak
    INCF    WREG	    ; Nie
    CPFSGT  funkcja	    ; czy 2 - ustawiamy minuty ?
    BRA	    zaznacz_minuty  ; Tak
teraz_anody:
    ; Ustawiliśmy katody. Teraz trzeba włączyć odpowiednią anodę. Cyfra pierwsza jest na RB4, druga na RB5, trzecia RB6
    ; czwarta na RB7
    MOVLW   B'00001000'	    ; Przesuwanie bitu zaczynamy spoza potrzebnego zakresu, bo jeden raz musimy przesunąć
    MOVFF   cyfra, tmp_wysw
przesuwaj_dalej:
    RLNCF   WREG
    DECFSZ  tmp_wysw, f    
    BRA	    przesuwaj_dalej
    NEGF    WREG	    ; negacja, bo sterujemy przez tranzystory PNP
    MOVWF   LATB	    ; włączamy anodę
    RETURN
zaznacz_godziny:
    MOVLW   2
    CPFSGT  cyfra
    BCF	    LATC, 7
    BRA	    teraz_anody
zaznacz_minuty:
    MOVLW   3
    CPFSLT  cyfra
    BCF	    LATC, 7
    BRA	    teraz_anody
    
    
zero	    EQU B'11000000'
jeden	    EQU B'11111001'
dwa	    EQU B'10100100'
trzy	    EQU B'10110000'
cztery	    EQU B'10011001'
piec	    EQU B'10010010'
szesc	    EQU B'10000010'
siedem	    EQU B'11111000'
osiem	    EQU B'10000000'
dziewiec    EQU B'10010000'
dziesiec    EQU B'10001000'
jedenascie  EQU B'10000011'
dwanascie   EQU B'11000110'
trzynascie  EQU B'10100001'
czternascie EQU B'10000110'
pietnascie  EQU B'10001110'
    
koduj1znak:
    ; oblicza kod-znak dla cyfry zawartej w WREG na najniższych bitach
    ANDLW   B'00001111'
    CLRF    czytotyle
    CPFSLT  czytotyle
    RETLW   zero
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   jeden
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   dwa
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   trzy
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   cztery
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   piec
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   szesc
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   siedem
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   osiem
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   dziewiec
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   dziesiec
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   jedenascie
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   dwanascie
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   trzynascie
    INCF    czytotyle,F
    CPFSLT  czytotyle
    RETLW   czternascie
    RETLW   pietnascie		; Nie trzeba sprawdzać, bo już nie ma więcej możliwości


; Poniższe podprogramy wg. opisu procesora PIC8F14K22
; PIC18(L)F1XK22 Data Sheet (DS41365E) str. 104
; EXAMPLE 10-1: IMPLEMENTING A REAL-TIME CLOCK USING A TIMER1 INTERRUPT SERVICE
; Zmodyfikowane tak, aby przerwania były co 1/256 sekundy
; zliczacz256	służy do doliczenia do 1 sekundy
; cyfra		wskazuje numer aktualnej cyfry do wyświetlenia

RTCinit:
    MOVLW	0xFF		; Preload TMR1 register pair
    MOVWF	TMR1H		; for 1/256 second overflow
    MOVLW	0x80
    MOVWF	TMR1L
    MOVLW	b'00001111'	; Configure for external clock,
    MOVWF	T1CON		; Asynchronous operation, external oscillator
    BSF		PIE1, TMR1IE	; Enable Timer1 interrupt
    MOVLW	.4
    MOVWF	cyfra		; dodatkowy dzielnik przez 4 (4,3,2,1, 4,3,2,1 ...)
    CLRF	zliczacz256	; dzielnik przez 256 (256 -> 0, 256...)
    RETURN

RTCisr:
    ; ta procedura powinna być wywoływana co 1 sekundę
    CLRF	WREG
    CPFSGT	funkcja		; Czy funkcja > 0
    BRA		RTCisr1		; Nie
    BCF		LATA, 0		; Tak. Dwukropek zapalony na stałe, gdy coś ustawiamy
    RETURN
RTCisr1:
    BTG		LATA, 2		; Zmiana dwukropka
    INCF	secs, F		; Zwiększ sekundy
    MOVLW	.59		; Czy osiągnięto 60 sekund?
    CPFSGT	secs
    RETURN			; Nie, wszystko zrobione
    CLRF	secs		; Wyzeruj sekundy
    INCF	mins,F		; Zwiększ minuty
    MOVLW	.59		; Czy osiągnięto 60 minut?
    CPFSGT	mins
    BRA		RTC_pominutach	; Nie, wszystko zrobione
    CLRF	mins		; wyzeruj minuty
    CALL	Koduj_Mins
    BRA		RTC_jeszczegodziny
RTC_pominutach:
    CALL	Koduj_Mins
    RETURN
RTC_jeszczegodziny:
    INCF	hours,F		; Zwiększ godziny
    MOVLW	.23		; Czy osiągnięto 24 godziny?
    CPFSGT	hours
    BRA		RTC_pogodzinach	; Nie, wszystko zrobione
    CLRF	hours		; Zresetuj godziny
RTC_pogodzinach:
    CALL	Koduj_Hours
    RETURN
    
przerwanie:
    MOVLW	0xFF
    MOVWF	TMR1H		; Preload for 1/256 sec overflow
    BSF		TMR1L, 7
    BCF		PIR1, TMR1IF	; Clear interrupt flag
    CALL	Wyswietl1znak
    DECFSZ	cyfra,f
    BRA		przerwanie1	; Nie trzeba zmieniać stanu zegara
    BSF		cyfra,2		; liczymy od 4 do 1; cykliczne DECFSZ doprowadziło do zera więc ustawiamy na powrót 4
przerwanie1:
    DCFSNZ	zliczacz256,f
    CALL	RTCisr
    RETFIE			; Done




    END  







